/* Doors for Linux.
   Copyright (C) 1998 Jason Lango

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2, or (at
   your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
**  doorsk.h - Kernel implementation of the Doors system calls.
**  Jason Lango <jal@cs.brown.edu>
*/

#include "door.h"

struct door_return_outargs;

#define DOORS_BANNER "Linux/Doors 0.9.0"
#define DOORS_DEVNAME "door"

extern const char *doors_banner;

int door_init(void);
int do_door_shutdown(void);
int do_door_create(void *server_procedure, void *cookie, u_int attributes);
int do_door_fattach(int fd, const char *name);
int do_door_fdetach(const char *name);
int do_door_wait_svr_create(door_info_t *info);
int do_door_call(int fd, door_arg_t *args);
int do_door_return(void *data_ptr, size_t data_size, door_desc_t *desc_ptr,
	size_t num_desc, char *argstash, size_t argstash_size,
	unsigned long munmap_addr, unsigned long munmap_len,
	struct door_return_outargs *outargs);
int do_door_info(int fd, struct door_info *info);
