/* Doors for Linux.
   Copyright (C) 1998 Jason Lango

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2, or (at
   your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
**  vm_copy.h - Copy-on-write an address range between processes.
**  Jason Lango <jal@cs.brown.edu>
*/

struct mm_struct;

/*	door_vm_copy

	Does a copy-on-write copy of the address range
	[src_addr, src_addr + src_len) from mm_src into a newly mapped
	address range in mm_dst.

	Optionally, allocates normal memory in the range
	[addr + src_len, addr + src_len + alloc_len) if alloc_len is non-zero.
*/

int door_vm_copy(struct task_struct *tsk_dst, struct task_struct *tsk_src,
	unsigned long src_addr, unsigned long src_len, unsigned long alloc_len,
	unsigned long *addr);
